# Copyright (c) 2014  Dave Love, University of Liverpool
# Licence as for the package itself

Name:		cryptominisat
Version:	4.0
Release:	1%{?dist}
Summary:	Parallel SAT solver
# Python support is MIT
License:	LGPLv2 and MIT
URL:		http://www.msoos.org/cryptominisat2/
Source0:	https://github.com/msoos/cryptominisat/archive/cryptoms-%version.tar.gz
Patch1:		cryptoms-python.patch
BuildRequires:	zlib-devel cmake
%if 0%{?rhel} && 0%{?rhel} <= 6
BuildRequires:	python-devel
%else
BuildRequires:	python2-devel
%endif
# C++ errors from EL6's gcc 4.4
%if 0%{?rhel} && %{?rhel} < 7
BuildRequires: devtoolset-2-gcc-gfortran
BuildRequires: devtoolset-2-binutils
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

%{?filter_setup:
%filter_from_requires /pycryptosat.so/d
%filter_setup
}

%description
CryptoMiniSat is a SAT solver that aims to become a premier SAT solver
with all the features and speed of successful SAT solvers, such as
MiniSat and PrecoSat.  The long-term goals of CryptoMiniSat are to be
an efficient sequential, parallel and distributed solver.

CryptoMiniSat 2.5 won the sequential category of the SAT Race 2010.  A
variation of CryptoMiniSat 2.7.1 won a gold and a silver medal in the
parallel category of the 2011 SAT Competition.

%package devel
Summary:	Development files for %{name}
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%prep
%setup -q -n cryptominisat-cryptoms-%version
%patch1 -p1


%build
%if 0%{?rhel} && %{?rhel} < 7
PATH=/opt/rh/devtoolset-2/root/usr/bin:$PATH
%endif
%cmake .
make %{?_smp_mflags}
cd python
make


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
if [ %_lib != lib ]; then
  mkdir -p $RPM_BUILD_ROOT%_libdir
  mv $RPM_BUILD_ROOT%_prefix/lib/*.so $RPM_BUILD_ROOT%_libdir
fi
mkdir -p $RPM_BUILD_ROOT%_datadir
mv $RPM_BUILD_ROOT%_prefix/lib/cmake $RPM_BUILD_ROOT%_datadir
install -D python/pycryptosat.so $RPM_BUILD_ROOT%python2_sitearch/pycryptosat.so
cp python/LICENSE LICENSE-python
cp python/README.rst README-python.rst


%clean
rm -rf $RPM_BUILD_ROOT

%check
make test


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%defattr(-,root,root,-)
%doc README.rst NEWS AUTHORS HOWTO-ANALYSIS HOWTO_opcontrol HOWTO_perf
%doc HOWTO_WEB LICENSE-LGPL LICENSE-python README-python.rst
%_libdir/libcryptominisat4.so
%_bindir/cryptominisat
%python2_sitearch/pycryptosat.so

%files devel
%_includedir/cryptominisat4
%_datadir/cmake/cryptominisat4


%changelog
* Mon Jul 14 2014 Dave Love <d.love@liverpool.ac.uk> - 4.0-1
- Initial packaging
